#include "stdafx.h"
#include <assert.h>
#include "AccessObjects.h"
#include "MultimediaTimer.h"
#include "SerialCOM.h"
#include "Timer.h"


CAccessObjects::CAccessObjects (const char *comPort, int comSpeed, DWORD readTimeout) : 
	_readTimeout(readTimeout) 
{
	// ־ COMƮ ̸(comPort)  ӵ(comSpeed) PC COMƮ Ѵ.
	_com = new CSerialCOM (comPort, comSpeed);
	if (_com->Open ()) { //  
		// COM Ʈ  MultimediaTimer 1ms Ͽ  ý
		//   ֱ⸦ δ. ̴ Sleep() Լ  ش.
		_mmt.Start (1);
		
		//   Ͱ   ϵ Timeout Ѵ.
		// CSerialCOM::Recv() Լ   ʰ RecvPacket() Լ  ̴.
		_com->SetTimeout (0, 1000, MAXDWORD); 

		//  Rx, Tx ۿ ٸ ڿ    ֱ⶧, 
		// Serial Text Ŷ  ڸ   ̸ .
		const char *crlfStr = "\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n\r\n";
		_com->Send (crlfStr, strlen(crlfStr));

		// PC   ۵ .
		ClearRxBuffer ();
	}
	else {	//  
		// CSerialCOM Ŭ ü Ѵ.
		delete _com;
		_com = NULL;
	}
}

CAccessObjects::~CAccessObjects () 
{ 
	//  CSerialCOM Ŭ ü ǰ ִٸ Ѵ.
	if (_com) {
		delete _com;
	}
}

bool CAccessObjects::ReadObject  (const char *objectName, double &value)
{
	// CSerialCOM Ŭ ü   false Ѵ.
	if (!_com) return false;

	// Լ  ð ϱ 
	PERFORM ("CAccessObjects::ReadObject()");

	//  ۿ ̹ ŵ Ͱ   ֱ⶧, ̸ .
	ClearRxBuffer ();

	//  ڿ 
	char buff[256+1];
	int n = _snprintf (buff, 256, "%s\n", objectName);

	// COM Ʈ ڿ Ѵ.
	n = _com->Send (buff, n);
	if (n <= 0) return false;

	// \r\n  ڿ ŵ  Ȥ ŸӾƿ   
	// COM Ʈ  ۸ д´.
	n = RecvPacket (buff, 256);
	if (n <= 0) return false;

	buff[n] = '\0'; //   ιڷ ݾش.

	//  Ʈ ̸ ŵ Ʈ ̸ ġϴ ˻
	if (strnicmp (objectName, buff, strlen(objectName)) != 0) return false;

	// ŵ ڿ "Ʈ ̸ = "  Ǿ ִ.
	// ⼭ '=' ڸ ã   ۵Ǵ ġ   ִ.
	char *assign = strchr (buff, '=');
	if (assign == NULL) return false;

	// ڿ ڷ ȯ
	value = strtod (assign + 1, NULL);
	return true;
}

bool CAccessObjects::WriteObject (const char *objectName, double  value)
{
	// CSerialCOM Ŭ ü   false Ѵ.
	if (!_com) return false;

	// Լ  ð ϱ 
	PERFORM ("CAccessObjects::WriteObject()");

	//  ۿ ̹ ŵ Ͱ   ֱ⶧, ̸ .
	ClearRxBuffer ();

	//  ڿ 
	char buff[256+1];
	int n = _snprintf (buff, 256, "%s=%g\n", objectName, value);

	// COM Ʈ ڿ Ѵ.
	n = _com->Send (buff, n);
	if (n <= 0) return false;

	// \r\n  ڿ ŵ  Ȥ ŸӾƿ   
	// COM Ʈ  ۸ д´.
	n = RecvPacket (buff, 256);
	if (n <= 0) return false;

	buff[n] = '\0';//   ιڷ ݾش.

	//  Ʈ ̸ ŵ Ʈ ̸ ġϴ ˻
	if (strnicmp (objectName, buff, strlen(objectName)) != 0) return false;

	return true;
}

void CAccessObjects::ClearRxBuffer ()
{
	int count;
	char buff[256];

	//  ۿ ̹ ŵ ͸ .
	while ((count = _com->CountRx ()) > 0) {
		_com->Recv (buff, min(sizeof(buff), count));
	}
}

int CAccessObjects::RecvPacket (char *buff, int buffSize)
{
	int count = 0;
	DWORD ts = CMultimediaTimer::GetTime ();

	// ŵ ڿ  \r\n̸  ϰ
	// ׷  б ŸӾƿ(_readTimeout)  ŴѴ.
	while (0 < buffSize) {
		int n = _com->Recv (&buff[count], buffSize);
		if (n > 0) {
			buffSize -= n;
			count += n;

			if (2 <= count && buff[count-2] == '\r' && buff[count-1] == '\n') {
				// ڿ  
				break;
			}
		}
		else if (n == 0) {
			Sleep (1);
		}
		else {
			// д   ߻
			return -1;
		}
		
		if (_readTimeout <= (CMultimediaTimer::GetTime () - ts)) {
			// б  ð 
			break;
		}
	}
	return count;		
}
