#pragma once

enum eFlowControl {
	FC_NONE = 0, 
	FC_XONXOFF, 
	FC_RTSCTS, 
	FC_DTRDSR,
	FC_FULLHARDWARE, 
};

class CSerialCOM
{
public:
	CSerialCOM (const char *portName, int baudRate, char dataBits = 8, char parity = NOPARITY, char stopBits = ONESTOPBIT, eFlowControl flowControl = FC_NONE);
	virtual ~CSerialCOM ();

	bool Open ();
	bool Close ();

	int  Send (const char *msg, int len);
	int  Recv (      char *msg, int len);
	void Purge ();

	bool SetTimeout (int readTimeout, int writeTimeout, int readIntervalTimeout);
	bool IsConnected () { return _comHandle != INVALID_HANDLE_VALUE; }
	int  CountRx ();

private:
	HANDLE _comHandle; 

	char _portName[32+1];
	int  _baudRate;
	char _dataBits;
	char _stopBits;
	char _parity;
	char _flowControl;

private:
	const char *CommErrorString (DWORD comError);
};
