
// StellaB3AppDlg.cpp : implementation file
//

#include "stdafx.h"
#include "StellaB3App.h"
#include "StellaB3AppDlg.h"
#include <Mmsystem.h>
#include "ControlStellaB3.h"
#include "UnitConv.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


double _maxLinearVel = 1.;	// m/s
double _maxAngularVel = 2.;	// rad/s

CControlStellaB3 *_mobility;


// CStellaB3AppDlg dialog
CStellaB3AppDlg::CStellaB3AppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStellaB3AppDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CStellaB3AppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CStellaB3AppDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_TIMER()
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CStellaB3AppDlg message handlers

BOOL CStellaB3AppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	_mobility = new CControlStellaB3 ();

	SetTimer (1000, 33, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CStellaB3AppDlg::OnDestroy()
{
	CDialog::OnDestroy();

	delete _mobility;
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CStellaB3AppDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CStellaB3AppDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CStellaB3AppDlg::OnTimer(UINT_PTR nIDEvent)
{
	// ̽ƽ о ư  ӵ(linearVel) Ⱒ(angularVel)  
	DWORD buttons = 0;
	double linearVel = 0.;
	double angularVel = 0.;
	
	// ̽ƽ ӵ Ⱒ о´.
	if (JoystickControl (linearVel, angularVel, buttons)) {
		// ӵ Ⱒ ִ ӵ Ͽ [-1, 1]  
		// [-max vel., +max vel.]   ȯѴ.
		linearVel  *= _maxLinearVel;
		angularVel *= _maxAngularVel;

		_mobility->Drive (linearVel, angularVel);

		char buff[256];
		sprintf (buff, "%7.3f, %7.3f", linearVel, angularVel);
		SetDlgItemText (IDC_EDIT_JOYSTICK_DESIRED_VELOCITY, buff);

		sprintf (buff, "%d, %d", _mobility->_leftEncoderPrev, _mobility->_rightEncoderPrev);
		SetDlgItemText (IDC_EDIT_ENCODER_VALUE, buff);

		sprintf (buff, "%.3f, %.3f %.1f", _mobility->_x, _mobility->_y, RAD2DEG*_mobility->_theta);
		SetDlgItemText (IDC_EDIT_ROBOT_POSITION, buff);
	}

	CDialog::OnTimer(nIDEvent);
}

bool CStellaB3AppDlg::JoystickControl (double &linearVel, double &angularVel, DWORD &buttons)
{
	// ̽ƽ Է ޴´.
	// ̽ƽ Է°  ӵ Ⱒ Ѵ.
	// ⼭ ӵ -1 1 , Ⱒ -1 1  ϵȴ.

	// ̽ƽ ణ ġ ִ   ݾ   ִ.
	// ׷ ̽ƽ ߾ӿ   dead zone ξ ̸ Ѵ.
	const double deadZone = 0.05;

	// ù ° ˻Ǵ ̽ƽ Ѵ.
	UINT joystickid = JOYSTICKID1;
	JOYINFOEX joyinfo;

	memset (&joyinfo, 0, sizeof(JOYINFOEX));
	joyinfo.dwSize = sizeof(JOYINFOEX);
	joyinfo.dwFlags = JOY_RETURNALL;

	if (joyGetPosEx(joystickid, &joyinfo) == JOYERR_NOERROR) {
		// ̽ƽ   ũ(-1 ~ 1) ٲ۴.
		// TRACE ("%8d %8d %8d\n", (int)joyinfo.dwXpos, (int)joyinfo.dwYpos, (int)joyinfo.dwZpos);
		double vel = (32768 - (long)joyinfo.dwYpos)/32768.;
		double ang = (32768 - (long)joyinfo.dwXpos)/32768.;

		if (-deadZone < vel && vel < deadZone) vel = 0.;
		if (-deadZone < ang && ang < deadZone) ang = 0.;

		linearVel = vel;
		angularVel = ang;
		buttons = joyinfo.dwButtons;
		return true;
	}
	return false;
}

